#ifndef bqtQBlibBstringFunHH
#define bqtQBlibBstringFunHH

#include <qblib/types.hh>
#include <qblib/stringfun.hh>
#include <qblib/basfun.hh>

const BAS_STR B_FuncSPACE_S(long n);
const BAS_STR B_FuncSTRING_S(long n, const BAS_STR& s);
const BAS_STR B_FuncSTRING_S(long n, int i);
const BAS_STR B_FuncCHR_S(long n);
const BAS_STR B_FuncSTR_S(BAS_DBL d);
const BAS_STR B_FuncSTR_S(long long int i);
const BAS_STR B_FuncHEX_S(BAS_DBL d);
const BAS_STR B_FuncHEX_S(BAS_LNG i);
const BAS_STR B_FuncHEX_S(long long i);
BAS_INT B_FuncASC(const BAS_STR& s);

static inline const BAS_STR B_FuncHEX_S(BAS_SGN d) { return B_FuncHEX_S(BAS_DBL(d)); }
static inline const BAS_STR B_FuncHEX_S(BAS_INT i) { return B_FuncHEX_S(BAS_LNG(i)); }
static inline const BAS_STR B_FuncSTR_S(BAS_LNG l) { return B_FuncSTR_S((long long int)l); }
static inline const BAS_STR B_FuncSTR_S(BAS_INT i) { return B_FuncSTR_S((long long int)i); }
static inline const BAS_STR B_FuncSTR_S(BAS_SGN s) { return B_FuncSTR_S((BAS_DBL)s); }

static inline const BAS_STR B_FuncLEFT_S(const BAS_STR& s, int count) { return BasLEFTs(s,count); }
static inline const BAS_STR B_FuncRIGHT_S(const BAS_STR& s, int count) { return BasRIGHTs(s,count); }
static inline const BAS_STR B_FuncMID_S(const BAS_STR& s, int pos, int count=-1) { return BasMIDs(s,pos,count); }
static inline const BAS_STR B_FuncLTRIM_S(const BAS_STR& s) { return LTrim(s); }
static inline const BAS_STR B_FuncRTRIM_S(const BAS_STR& s) { return RTrim(s); }
static inline const BAS_STR B_FuncUCASE_S(const BAS_STR& s) { return UCase(s); }
static inline const BAS_STR B_FuncLCASE_S(const BAS_STR& s) { return LCase(s); }

#endif
