#include <cstdlib>
#include "exec.hh"
#include "error.hh"
#include "gosub.hh"
#include "stream.hh"
#include "gfx.hh"

void B_LibInit()
{
    GFX_Init();
}

void B_LibDone()
{
    GFX_Done();
}

void B_StmtEND(int code)
{
    B_LibDone();
    std::exit(code);
    
    fprintf(stderr, "Eh, huh? std::exit returned?\n"); fflush(stderr);
}

void B_StmtSYSTEM(int code)
{
    B_StmtEND(code);
}

void B_StmtSTOP()
{
/*
    B_LibDone();
    std::abort();
*/
    int p;
    fprintf(stderr, "SP=%p\r\n", &p);
    fflush(stderr);
}

void B_CLEAR(int ds_size,int,int ss_size, bool in_sub)
{
    /* Note: If called from within a SUB,
     * QuickBASIC throws error 5 (Illegal function call).
     * We, however tolerate such usage...
     */
    
    ds_size=ds_size; // ignored
    ss_size=ss_size; // ignored
    
    GosubStack.clear(); // Defined to do so in QB manual
    
    /* TODO: Close all open files */
    
    ON_ERROR_GOTO_NOWHERE();
    
    /* This clears possible active error. */
    if(B_ERR_VALUE)
    {
        /* This is wrong. It should return to where CLEAR
         * was issued, not to where the error occurred.
         */
        B_RESUMENEXT();
    }
}

void B_StmtBEEP()
{
    GET_STDOUT() << (char)7;
}

