#include <cctype>

#include "stringfun.hh"

const std::string RTrim(const std::string& b, char with)
{
    unsigned size = b.size();
    while(size > 0 && b[size-1] == with)--size;
    return b.substr(0, size);
}

const std::string LTrim(const std::string& b, char with)
{
    unsigned strip=0;
    for(unsigned a=0; a<b.size() && b[a]==with; ++a)++strip;
    return b.substr(strip);
}

const std::string RTrim(const std::string& s)
{
    std::string::size_type q = 0; /* Number of chars to eat */
    while(q < s.size() && (s[s.size()-q-1] == ' '
                        || s[s.size()-q-1] == '\t')) ++q;
    return s.substr(0, s.size()-q);
}

const std::string LTrim(const std::string& s)
{
    std::string::size_type p = 0;
    while(p < s.size() && (s[p] == ' ' || s[p] == '\t')) ++p;
    return s.substr(p);
}

const std::string Trim(const std::string& s)
{
    std::string::size_type p = 0;
    while(p < s.size() && (s[p] == ' ' || s[p] == '\t')) ++p;

    std::string::size_type q = 0;
    while((p+q) < s.size() && (s[s.size()-q-1] == ' ' || s[s.size()-q-1] == '\t')) ++q;

    return std::string(s.data()+p, s.size()-p-q);
}

const std::string LCase(const std::string& s)
{
    std::string result = s;
    for(unsigned a=0; a<result.size(); ++a)
        result[a] = std::tolower(result[a]);
    return result;
}

const std::string UCase(const std::string& s)
{
    std::string result = s;
    for(unsigned a=0; a<result.size(); ++a)
        result[a] = std::toupper(result[a]);
    return result;
}

